#!/bin/sh

if [ $1 == "-n" ]; then
  echo -n "Gtk Project (C)"
else

# Set more intuitive variable names
LOCATION=$1
NAME=$2
AUTHOR=$3
HOMEPAGE=$4
VERSION=$5
EMAIL=$6

SRCDIR="${LOCATION}src/"
echo "Creating directory: ${LOCATION}"
mkdir $LOCATION
echo "Creating directory: ${SRCDIR}"
mkdir $SRCDIR

FILE="${LOCATION}AUTHORS"
CONTENT="${AUTHOR} [${EMAIL}]"
echo "Creating file: ${FILE}"
echo -e "$CONTENT" > $FILE

FILE="${LOCATION}autogen.sh"
echo "Creating file: ${FILE}"
echo -e "#!/bin/sh\necho \"Running aclocal\"\naclocal\necho \"Running automake\"\nautomake --add-missing\necho \"Running autoconf\"\nautoconf\necho \"Running configure\"\n./configure" > $FILE
chmod 777 $FILE

FILE="${LOCATION}ChangeLog"
CONTENT=""
echo "Creating file: ${FILE}"
echo -e "$CONTENT" > $FILE

FILE="${LOCATION}config.h.in"
CONTENT="#undef PACKAGE\n#undef PACKAGE_BUGREPORT\n#undef PACKAGE_NAME\n#undef PACKAGE_STRING\n#undef PACKAGE_TARNAME\n#undef PACKAGE_VERSION\n#undef STDC_HEADERS\n#undef VERSION"
echo "Creating file: ${FILE}"
echo -e "$CONTENT" > $FILE

FILE="${LOCATION}configure.in"
CONTENT="AC_INIT(configure.in)\nAM_INIT_AUTOMAKE(${NAME}, ${VERSION})\nAC_PREFIX_DEFAULT(\"/usr\")\nAM_CONFIG_HEADER(config.h)\n\nCFLAGS=""\nAC_SUBST(CFLAGS)\nAC_ISC_POSIX\nAC_PROG_CC\nAM_PROG_CC_STDC\nAC_HEADER_STDC\n\nPKG_CHECK_MODULES(PACKAGE, gtk+-2.0 >= 2.0.0)\nAC_SUBST(PACKAGE_CFLAGS)\nAC_SUBST(PACKAGE_LIBS)\n\nAC_OUTPUT([ Makefile src/Makefile ])"
echo "Creating file: ${FILE}"
echo -e "$CONTENT" > $FILE

FILE="${LOCATION}Makefile.am"
CONTENT="SUBDIRS = src\n\n${NAME}docdir = \$(prefix)/share/doc/${NAME}\n${NAME}doc_DATA = README COPYING AUTHORS ChangeLog INSTALL NEWS TODO\n\nEXTRA_DIST = \$(${NAME}doc_DATA)"
echo "Creating file: ${FILE}"
echo -e "$CONTENT" > $FILE

FILE="${LOCATION}NEWS"
CONTENT=""
echo "Creating file: ${FILE}"
echo -e "$CONTENT" > $FILE

FILE="${LOCATION}README"
CONTENT="For more information, visit: ${HOMEPAGE}"
echo "Creating file: ${FILE}"
echo -e "$CONTENT" > $FILE

FILE="${LOCATION}TODO"
CONTENT=""
echo "Creating file: ${FILE}"
echo -e "$CONTENT" > $FILE

FILE="${SRCDIR}main.c"
CONTENT="/***************************************************************************\n *   This program is free software; you can redistribute it and/or modify  *\n *   it under the terms of the GNU General Public License as published by  *\n *   the Free Software Foundation; either version 2 of the License, or     *\n *   (at your option) any later version.                                   *\n *                                                                         *\n *   This program is distributed in the hope that it will be useful,       *\n *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *\n *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *\n *   GNU General Public License for more details.                          *\n *                                                                         *\n *   You should have received a copy of the GNU General Public License     *\n *   along with this program; if not, write to the                         *\n *   Free Software Foundation, Inc.,                                       *\n *   59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.              *\n ***************************************************************************/\n\n#include <gtk/gtk.h>\n\nstatic gboolean\ndelete_event (GtkWidget *widget,\n              GdkEvent *event,\n              gpointer data )\n{\n  return FALSE;\n}\n\nstatic void\ndestroy (GtkWidget *widget,\n         gpointer data)\n{\n  gtk_main_quit ();\n}\n\nint main (int argc, char *argv[])\n{\n  GtkWidget *window;\n\n  gtk_init (&argc, &argv);\n  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);\n  gtk_widget_show (window);\n\n  g_signal_connect (G_OBJECT (window), \"delete_event\",\n                    G_CALLBACK (delete_event), NULL);\n  g_signal_connect (G_OBJECT (window), \"destroy\",\n             	      G_CALLBACK (destroy), NULL);\n\n  gtk_main ();\n  return 0;\n}"
echo "Creating file: ${FILE}"
echo -e "$CONTENT" > $FILE

FILE="${SRCDIR}Makefile.am"
CONTENT="INCLUDES = \$(PACKAGE_CFLAGS)\n\nAM_CFLAGS = -Wall -g\n\nbin_PROGRAMS = ${NAME}\n\n${NAME}_SOURCES = main.c\n\n${NAME}_LDADD = \$(PACKAGE_LIBS)"
echo "Creating file: ${FILE}"
echo -e "$CONTENT" > $FILE

FILE="${LOCATION}${NAME}.dev"
CONTENT="<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<OpenLDevProject version=\"0.6+\">\n  <ProjectTemplate>gtk</ProjectTemplate>\n  <OpenFile>${SRCDIR}main.c</OpenFile>\n  <Language>C</Language>\n  <AutoGenerate>./autogen.sh</AutoGenerate>\n  <Build>make</Build>\n  <Clean>make clean</Clean>\n  <Compile>make {FILE}</Compile>\n  <Configure>./configure</Configure>\n  <Execute>{BASE}src/{NAME}</Execute>\n</OpenLDevProject>"
echo "Creating file: ${FILE}"
echo -e "$CONTENT" > $FILE

fi
